import bin.rm as rm
import numpy as np
import argparse
import bin.functions as md

# Parse the command line options
parser = argparse.ArgumentParser(description='',
                                 formatter_class=argparse.RawTextHelpFormatter)
parser.add_argument("dataFile", metavar="dataFile.dat", nargs=1,
                    help="ASCII file containing Stokes spectra & errors.")
parser.add_argument("-fmin", dest="fmin", type=int, default=700,
                    help="minimum frequency [MHz].")
parser.add_argument("-fmax", dest="fmax", type=int, default=1800,
                    help="maximum frequency [MHz].")
# parser.add_argument("-p", dest="showPlots", action="store_true",
#                     help="show the plots [False].")
args = parser.parse_args()

filename = args.dataFile[0]

fmin = args.fmin
fmax = args.fmax
l2min = md.FtoL2(fmax)
l2max = md.FtoL2(fmin)

print '         Frequency: %d - %d [MHz]'%(args.fmin,args.fmax)
print 'Squared wavelength: %5.3lf - %5.3lf [m^2]'%(l2min,l2max)


f = np.loadtxt(filename)
f = np.delete(f,np.where(f<l2min)[0][np.where(np.where(f<l2min)[1]==0)],0)
f = np.delete(f,np.where(f>l2max)[0][np.where(np.where(f>l2max)[1]==0)],0)

lam2 = f[:,0]
qdata = f[:,1]
udata = f[:,2]
qerr = f[:,3]
uerr = f[:,4]

p = rm.PolObservation(lam2,(qdata,udata),QUerr=(qerr,uerr))
#phi_axis = np.arange(-250.,250.1,.1)
phi_axis = np.arange(-250.,250.1,1.)

p.calc_model(phi_axis,filename)
p.rmsynthesis(phi_axis)
p.plot_fdf()
